# Default

Like `def x(y=nil)`, but less infuriating.

## Installation

Add this line to your application's Gemfile:

    gem 'default'

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install default

## Usage

```ruby
require 'default'

def test(arg1 = default)
  # This is just syntactic sugar for `arg1 == default`
  arg1.default?
end

test               #=> true
test(1)            #=> false
test(nil)          #=> false
test(:default)     #=> false # Common alternative to nil.
test(DefaultValue) #=> true  # Well, it has to be equal to something, now doesn't it?


def test2(arg1 = default)
  arg1
end

test2 #=> DefaultValue


def test3(arg1 = default)
  arg1 = "default value for arg1" if arg1.default?

  arg1
end

test3         #=> "default value for arg1"
test3("foo")  #=> "foo"
```

## Contributing

1. Fork it ( https://github.com/duckinator/default/fork )
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create a new Pull Request
